package u1a3;

/**
 * Ancient Egyptian multiplication
 * @author Alexander Bernauer (bernauer@inf.ethz.ch)
 * @version 1.0
 */
public class Mult {
    private static int f(int a, int b) {
        if (b==0) return a;
        if (b%2 == 0) return f(2*a, b/2);
        else return a + f(2*a, b/2);
    }
    
/**
 * This function implements the ancient Egyptian multiplication.
 *
 * @param a must be a positive integer
 * @param b must be a positive integer
 * @return the product of a and b
 * @throws IllegalArgumentException if a or b is not positive
 */
    public static int mult(int a, int b) {

        return f(a, b);
    }
}
